#!/usr/bin/perl -w
# $Id: verstuff.pl,v 1.3.2.1 2003/11/04 14:38:04 chrisgreen Exp $
# Author: Chris Green <cmg@sourcefire.com>
# Purpose: make sure snort versions stay in sync
# Created: Tue Jul 22 17:21:42 EDT 2003

use strict;

my $version = "Unknown!";

if($#ARGV < 0)
{
    die "bad args found!\n";
}

my $prefix = $ARGV[0];

open(CONFIGURE,"$prefix/configure.in") or die "Can't open configure.in!\n";

while(<CONFIGURE>)
{
    if($_ =~ m/^AM_INIT_AUTOMAKE\(snort,/)
    {
	chomp;
	$version = $_;
	$version =~ s/^AM_INIT_AUTOMAKE\(snort,([^\)]+)\)/$1/;
	last;
    }
}
close(CONFIGURE);


# print "version is $version!\n";

open(WIN32CONFIG, "$prefix/src/win32/WIN32-Includes/config.h");
open(WIN32CONFIGNEW, ">$prefix/src/win32/WIN32-Includes/config.h.new");

while(<WIN32CONFIG>)
{
    if($_ =~ m/^\#define VERSION "[^"]+"/)
    {
	$_ =~ s/^(\#define VERSION ")[^"]+(.*$)/${1}${version}${2}/;
    }

    print WIN32CONFIGNEW $_;
}

system("mv -f ${prefix}/src/win32/WIN32-Includes/config.h.new ${prefix}/src/win32/WIN32-Includes/config.h");

# take care of the rpm stuff
open(SPEC, "$prefix/contrib/rpm/snort.org.spec") or die;
open(SPECNEW, ">$prefix/contrib/rpm/snort.org.spec.new") or die;

print "Replacing Verstuff!\n";
while(<SPEC>)
{
    # replace the version line in the spec file
    if($_ =~ m/^Version: VERSION/)
    {
	$_ = "Version: $version\n";
    }

    print SPECNEW $_;
}

system("mv -f $prefix/contrib/rpm/snort.org.spec.new $prefix/contrib/rpm/snort.org.spec");
